"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var CommonApi = __importStar(require("../definitions/Common/CommonApi"));
var OposGkApi_1 = require("../definitions/OposGkApi");
exports.apiPrefix = "comGkSoftwareGkrAppEnablementApi.Common/";
var OPosCommonApi = (function (_super) {
    __extends(OPosCommonApi, _super);
    function OPosCommonApi(invokeOposMethod, oposEventRegistration, oposCancellEventRegistration) {
        var _this = _super.call(this, CommonApi.apiName, exports.apiPrefix, invokeOposMethod) || this;
        _this.oposEventRegistration = oposEventRegistration;
        _this.oposCancellEventRegistration = oposCancellEventRegistration;
        return _this;
    }
    OPosCommonApi.prototype.getSessionContext = function (appCallback) {
        var invocation = this.prepareInvoke("getSessionContext");
        invocation.callback = appCallback;
        this.invokeOposMethod(invocation);
    };
    OPosCommonApi.prototype.registerListener = function (eventHandler, eventName, registrationId, expectData) {
        if (expectData === void 0) { expectData = false; }
        this.oposEventRegistration({
            event: eventName,
            listener: eventHandler,
            id: registrationId,
            passData: expectData,
            prefix: this.apiPrefix
        });
    };
    OPosCommonApi.prototype.unregisterListener = function (eventName, registrationId) {
        this.oposCancellEventRegistration({
            event: eventName,
            listener: function () { },
            id: registrationId,
            passData: false,
            prefix: this.apiPrefix
        });
    };
    OPosCommonApi.prototype.closeBrowser = function () {
        var invocation = this.prepareInvoke("closeBrowser");
        this.invokeOposMethod(invocation);
    };
    OPosCommonApi.prototype.hideBrowser = function () {
        var invocation = this.prepareInvoke("hideBrowser");
        this.invokeOposMethod(invocation);
    };
    OPosCommonApi.prototype.getOperatorData = function (appCallback) {
        var invocation = this.prepareInvoke("getOperatorData");
        invocation.callback = appCallback;
        this.invokeOposMethod(invocation);
    };
    return OPosCommonApi;
}(OposGkApi_1.OposGkApi));
exports.OPosCommonApi = OPosCommonApi;
