import * as CommonApi from "../definitions/Common/CommonApi";
import { OposGkApi } from "../definitions/OposGkApi";
import { IOPosInvoke } from "../definitions/IOPosInvoke";
import { ApiResponse } from "../definitions/ApiResponse";
export interface IRegistrationEventCall {
    id: string;
    event: string;
    listener: (data: any) => void;
    passData: boolean;
    prefix: string;
}
export declare const apiPrefix = "comGkSoftwareGkrAppEnablementApi.Common/";
export declare class OPosCommonApi extends OposGkApi implements CommonApi.ICommonApi {
    oposEventRegistration: (data: IRegistrationEventCall) => void;
    oposCancellEventRegistration: (data: IRegistrationEventCall) => void;
    constructor(invokeOposMethod: (data: IOPosInvoke) => void, oposEventRegistration: (data: IRegistrationEventCall) => void, oposCancellEventRegistration: (data: IRegistrationEventCall) => void);
    getSessionContext(appCallback: ApiResponse<CommonApi.CommonApiDTO.IContext>): void;
    registerListener(eventHandler: (data: any) => void, eventName: string, registrationId: string, expectData?: boolean): void;
    unregisterListener(eventName: string, registrationId: string): void;
    closeBrowser(): void;
    hideBrowser(): void;
    getOperatorData(appCallback: ApiResponse<CommonApi.CommonApiDTO.IOperator>): void;
}
