"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var PosApi = __importStar(require("../definitions/Pos/PosApi"));
var OposGkApi_1 = require("../definitions/OposGkApi");
exports.apiPrefix = "comGkSoftwareGkrAppEnablementApi.Pos/";
var OPosPosApi = (function (_super) {
    __extends(OPosPosApi, _super);
    function OPosPosApi(invokeOposMethod) {
        return _super.call(this, PosApi.apiName, exports.apiPrefix, invokeOposMethod) || this;
    }
    OPosPosApi.prototype.getPOSItemInformationByID = function (appCallback, data) {
        var invocation = this.prepareInvoke("getPOSItemInformationByID");
        invocation.callback = appCallback;
        invocation.data = data;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.registerLineItem = function (appCallback, data) {
        var invocation = this.prepareInvoke("registerLineItem");
        invocation.callback = appCallback;
        invocation.data = data;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.registerExternalLineItem = function (appCallback, data) {
        var invocation = this.prepareInvoke("registerExternalLineItem");
        invocation.callback = appCallback;
        invocation.data = data;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.addAdditionalTransactionReport = function (appCallback, data) {
        var invocation = this.prepareInvoke("addAdditionalTransactionReport");
        invocation.callback = appCallback;
        invocation.data = data;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.getCurrentTransaction = function (appCallback) {
        var invocation = this.prepareInvoke("getCurrentTransaction");
        invocation.callback = appCallback;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.cancelCurrentTransaction = function (appCallback, data) {
        var invocation = this.prepareInvoke("cancelCurrentTransaction");
        invocation.callback = appCallback;
        invocation.data = data;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.addTransactionExtension = function (appCallback, data) {
        var invocation = this.prepareInvoke("addTransactionExtension");
        invocation.callback = appCallback;
        invocation.data = data;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.updateTransactionExtension = function (appCallback, data) {
        var invocation = this.prepareInvoke("updateTransactionExtension");
        invocation.callback = appCallback;
        invocation.data = data;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.deleteTransactionExtension = function (appCallback, data) {
        var invocation = this.prepareInvoke("deleteTransactionExtension");
        invocation.callback = appCallback;
        invocation.data = data;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.getCurrentCustomerList = function (appCallback) {
        var invocation = this.prepareInvoke("getCurrentCustomerList");
        invocation.callback = appCallback;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.registerCustomer = function (appCallback, data) {
        var invocation = this.prepareInvoke("registerCustomer");
        invocation.callback = appCallback;
        invocation.data = data;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.onLineItemRegistrationFinished = function (appCallback) {
        var invocation = this.prepareInvoke("onLineItemRegistrationFinished");
        invocation.callback = appCallback;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.getLastNotVoidedTransaction = function (appCallback) {
        var invocation = this.prepareInvoke("getLastNotVoidedTransaction");
        invocation.callback = appCallback;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.printReport = function (appCallback, data) {
        var invocation = this.prepareInvoke("printReport");
        invocation.callback = appCallback;
        invocation.data = data;
        this.invokeOposMethod(invocation);
    };
    OPosPosApi.prototype.enterCoupon = function (appCallback, data) {
        var invocation = this.prepareInvoke("enterCoupon");
        invocation.callback = appCallback;
        invocation.data = data;
        this.invokeOposMethod(invocation);
    };
    return OPosPosApi;
}(OposGkApi_1.OposGkApi));
exports.OPosPosApi = OPosPosApi;
